## opengm 2.3.6%2B20160905

=== src/interfaces/python/opengm/hdf5/CMakeLists.txt ===
#--------------------------------------------------------------
# Find packages
#--------------------------------------------------------------


 message(STATUS "build opengm python with HDF5 support")
 if ( WITH_HDF5 )
   #find_package(HDF5 REQUIRED)
 else()
   message( FATAL_ERROR "Option  WITH_HDF5  needs to be activated to compile the OpenGM Python Wrapper" )
 endif()
 find_package(NUMPY) 
 include_directories(${HDF5_INCLUDE_DIR})
 add_definitions(${HDF5_CPPFLAGS})
 add_definitions(-DWITH_HDF5)

#--------------------------------------------------------------
# Include Directories
#--------------------------------------------------------------
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
	 ${PYTHON_INCLUDE_DIRS}
	 ${PYTHON_NUMPY_INCLUDE_DIR}
    ${Boost_INCLUDE_DIR}
    ${Boost_PYTHON_INCLUDE_DIR}
)





#--------------------------------------------------------------
# Add opengmcore library
#--------------------------------------------------------------
if(APPLE)
    add_library(_hdf5 MODULE 
    hdf5.cpp
    pyHdf5.cxx
    )
else()
    add_library(_hdf5 SHARED  
    hdf5.cpp
    pyHdf5.cxx
    )
endif(APPLE)





#--------------------------------------------------------------
# Link libraries
#--------------------------------------------------------------
if(MSVC AND NOT(MSVC_VERSION LESS 1400))
    SET_TARGET_PROPERTIES(_hdf5 PROPERTIES COMPILE_FLAGS "/bigobj")
endif()
target_link_libraries(_hdf5 ${Boost_PYTHON_LIBRARIES}  ${HDF5_LIBRARIES})
set_target_properties(_hdf5 PROPERTIES PREFIX "")



IF(WIN32)
    SET_TARGET_PROPERTIES(_hdf5 PROPERTIES OUTPUT_NAME "hdf5"  PREFIX "_" SUFFIX  ".pyd")
ELSEIF(APPLE)
    SET_TARGET_PROPERTIES(_hdf5 PROPERTIES OUTPUT_NAME "hdf5" PREFIX "_" SUFFIX ".so")
ELSE()
    SET_TARGET_PROPERTIES(_hdf5 PROPERTIES OUTPUT_NAME "hdf5"   PREFIX "_")
ENDIF()



#--------------------------------------------------------------
# Copy from src to build
#--------------------------------------------------------------

if( ${CMAKE_CURRENT_SOURCE_DIR} STREQUAL  ${CMAKE_CURRENT_BINARY_DIR} )
   message(STATUS "same src and build dir.")
else()
   message(STATUS "copy python-hdf5 files  from src to build" )
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR} )
endif()

=== debian/changelog ===
opengm (2.3.6+20160905-1build2) zesty; urgency=medium

  * Rebuild against new hdf5

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 29 Nov 2016 17:35:55 +0000

opengm (2.3.6+20160905-1build1) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:33:50 +0000

opengm (2.3.6+20160905-1) unstable; urgency=medium

  * New upstream snapshot. (Closes: #836413)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 06 Sep 2016 07:50:24 +0100

opengm (2.3.6+20160901-1) unstable; urgency=medium

  * New upstream snapshot. (Closes: #836216)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 02 Sep 2016 11:43:07 +0100

opengm (2.3.6+20160814-1) unstable; urgency=medium

  * New upstream snapshot. (Closes: #806379, #811878)
  * Update patch queue.
    - Drop disable-mem-logging-by-default.patch, applied upstream.
    - Drop fix-hdf5-detection.patch, fixed upstream.
  * Bump standards version to 3.9.8, no changes required.
  * Drop build of examples.
  * Skip usage of RPATH with CMake.
  * Assorted enhancements to rules file:
    - Add missing DEB_CXXFLAGS_MAINT_APPEND option.
    - Simplify and correct dh_auto_test override.
    - Remove superfluous comments.
    - Wrap, sort and format.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 30 Aug 2016 16:58:33 +0100

opengm (2.3.6+20160131-2) unstable; urgency=medium

  * Remove build dependency on vigra, not required.
  * d/rules: simplify dh_auto_test override.
  * d/rules: improve comments.
  * Add upstream patch fixing FBTFS errors on kfreebsd and hurd.
  * Install Python examples to the python-opengm-doc package.
  * d/u/metadata: fix formatting error.
  * d/gbp.conf: change packaging branch to debian/master (DEP-14).

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 02 Apr 2016 12:09:26 +0100

opengm (2.3.6+20160131-1) unstable; urgency=medium

  * Team upload.

  [Ghislain Antony Vaillant]
  * Drop patch Fix-testsuite-execution-on-32-bit.patch,
    applied upstream.
  * Provide examples in doc package.
  * d/rules: build examples conditionally on nocheck.
  * d/gbp.conf: use upstream tag format.
  * d/rules: simplify dh_autotest override.
  * d/control: use secure VCS URIs.
  * Fix usage of embedded jquery in doc package.
  * d/rules: move dh_numpy call to dh_python2 override.
  * d/rules: exclude examples from compression.
  * Bump standards version to 3.9.7, no changes required.

  [Andreas Tille]
  * Avoid mixed quote signs in debian/upstream/metadata

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 14 Feb 2016 14:27:29 +0000

## opengm 2.3.6+20160905

=== CMakeLists.txt ===
#--------------------------------------------------------------
# default build-type (release)
# (the next lines must be called bevore project(opengm2))
#--------------------------------------------------------------
IF(DEFINED CMAKE_BUILD_TYPE)
   SET(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ELSE()
   SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF()

#--------------------------------------------------------------
# OpenGM
#--------------------------------------------------------------
cmake_minimum_required(VERSION 2.6)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
project(opengm2)
set (OPENGM_VERSION_MAJOR 2)
set (OPENGM_VERSION_MINOR 3)
set (OPENGM_VERSION_PATCH 1)

#--------------------------------------------------------------
# global headers
#--------------------------------------------------------------
file(GLOB_RECURSE headers include/*.hxx)
include_directories(include)

#--------------------------------------------------------------
# debug info
#--------------------------------------------------------------
#add_definitions(-DTRWS_DEBUG_OUTPUT)

#--------------------------------------------------------------
# warning level
#-------------------------------------------------------------- 
SET(WARNINGLEVEL "0" CACHE STRING "selected level for compiler warning from  0 (sloppy) to 4 (sadistic)") 
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
   # no warnings
   if(WARNINGLEVEL STREQUAL "0" )
     message(STATUS "--------------------------------------------------------------------------")
     message(STATUS "WARNING: Compiler warnings are very sloppy -> increase CMake-WARNINGLEVEL")
     message(STATUS "--------------------------------------------------------------------------")
   endif()
   # with warning
   if(WARNINGLEVEL STREQUAL "1" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98")
   endif()
   # PEDANTIC -> a lot of warnings
   if(WARNINGLEVEL STREQUAL "2" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long ")
   endif() 
   # VERY PEDANTIC -> very lot of warnings
   if(WARNINGLEVEL STREQUAL "3" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long -Wextra")
   endif()
   # SADISTIC -> all warnings become errors
   if(WARNINGLEVEL STREQUAL "4" )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++98 -pedantic -Wno-long-long -Wextra -Werror")
   endif()
elseif(MSVC)
   add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()


#--------------------------------------------------------------
# options
#--------------------------------------------------------------
OPTION(BUILD_EXAMPLES "Build Examples" ON)
OPTION(BUILD_TUTORIALS "Build Tutorials" ON)
OPTION(BUILD_COMMANDLINE "Build Commandline" OFF)
OPTION(WITH_AD3 "Include AD3" OFF)
OPTION(WITH_CPLEX "Include CPLEX" OFF)
OPTION(WITH_GUROBI "Include GUROBI" OFF)
OPTION(WITH_BOOST "Include BOOST" OFF)
OPTION(WITH_HDF5 "Include HDF5" OFF)
OPTION(WITH_TRWS "Include wrapper for TRWS code" OFF)
OPTION(WITH_GCO "Include wrapper for GCO code" OFF)
OPTION(WITH_MRF "Include wrapper for MRF code" OFF)
OPTION(WITH_QPBO "Include wrapper for QPBO code" OFF)
OPTION(WITH_FASTPD "Include wrapper for FastPD code" OFF)
OPTION(WITH_MAXFLOW "Include wrapper for MAXFLOW code" OFF)
OPTION(WITH_MAXFLOW_IBFS "Include wrapper for MAXFLOW-IBFScode" OFF)
OPTION(WITH_LIBDAI "Include wrapper for LIBDAI code" OFF)
OPTION(WITH_DAOOPT "Include wrapper for DAOOPT code" OFF)
OPTION(WITH_MPLP "Include wrapper for MPLP code" OFF)
OPTION(WITH_SRMP "Include wrapper for SRMP code" OFF)
OPTION(WITH_PLANARITY "Include wrapper for PLANARITY code" OFF)
OPTION(WITH_BLOSSOM5 "Include wrapper for BLOSSOM5 code" OFF)
OPTION(WITH_OPENMP "Include OpenMP" OFF)
OPTION(WITH_VIGRA "Include VIGRA" OFF)
OPTION(WITH_CONICBUNDLE "Include ConicBundleLibrary" OFF)
OPTION(WITH_MATLAB "Activate MatLab-Code" OFF)
OPTION(BUILD_CONVERTER "Build several converters" OFF)
OPTION(BUILD_PYTHON_WRAPPER "Build python wrapper" OFF)
OPTION(BUILD_MATLAB_WRAPPER "Build matlab wrapper" OFF)
###Grante needs C++11. Since we have not tested OpenGM under this standard yet, using Grante is realy experimental!!!
###OPTION(WITH_GRANTE "Include wrapper for grante" OFF)
OPTION(WITH_MEMINFO "Use memory logging in visitor" OFF)


INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(BIGENDIAN)
IF(${BIGENDIAN})
     ADD_DEFINITIONS(-DBIGENDIAN)
ENDIF(${BIGENDIAN})

#--------------------------------------------------------------
# MEMINFO
#--------------------------------------------------------------
if(WITH_MEMINFO)
  add_definition(-DSYS_MEMORYINFO_ON)
endif()
#--------------------------------------------------------------
# Cplex
#--------------------------------------------------------------
if(WITH_CPLEX)
   message(STATUS "build with CPLEX interface")
   find_package(CPLEX REQUIRED)
   add_definitions(-DWITH_CPLEX)
   include_directories(${CPLEX_INCLUDE_DIRS})
   # add_definitions(-DILOUSESTL) redundant according to http://www-01.ibm.com/support/docview.wss?uid=swg21399983
   add_definitions(-DIL_STD)
else()
   message(STATUS "build without CPLEX interface")
endif()


#--------------------------------------------------------------
# AD3
#--------------------------------------------------------------
if(WITH_AD3)
   #message(STATUS "build with AD3 interface")
   #find_package(AD3 REQUIRED)
   #add_definitions(-DWITH_AD3)
   #include_directories(${AD3_INCLUDE_DIR})


  message(STATUS "build with external inference algorithm AD3")
  SET(AD3_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/AD3-patched" CACHE STRING "AD3 patched source code directory")
  add_definitions(-DWITH_AD3)
  include_directories(${AD3_PATCHEDSRCDIR})



else()
   message(STATUS "build without AD3 interface")
endif()

#--------------------------------------------------------------
# Gurobi
#--------------------------------------------------------------
if(WITH_GUROBI)
   message(STATUS "build with GUROBI interface")
   find_package(GUROBI REQUIRED)
   add_definitions(-DWITH_GUROBI)
   include_directories(${GUROBI_INCLUDE_DIRS})
else()
   message(STATUS "build without GUROBI interface")
endif()



#--------------------------------------------------------------
# Boost
#--------------------------------------------------------------
if(WITH_BOOST)
   message(STATUS "build with Boost")
   find_package(Boost 1.47 REQUIRED)
   add_definitions(-DWITH_BOOST)
   add_definitions(-DWITH_BOOST_GRAPH)
   include_directories(${Boost_INCLUDE_DIR})
else()
   message(STATUS "build without Boost")
endif()

#--------------------------------------------------------------
# HDF5
#--------------------------------------------------------------
if(WITH_HDF5)
   message(STATUS "build with HDF5 support")
   if(WIN32)
     # FindHDF5 is broken on Windows
     # it wrongly discovers the dlls instead of the lib files
     # see: www.cmake.org/Bug/bug_relationship_graph.php?bug_id=14111
     # therefore we set the variable manually
     find_library( HDF5_IMPORT_LIB NAMES hdf5 hdf5dll )
     find_library( HDF5_HL_IMPORT_LIB NAMES hdf5_hl hdf5_hldll )
     find_path(HDF5_INCLUDE_DIR hdf5.h)
     set( HDF5_LIBRARIES ${HDF5_IMPORT_LIB} ${HDF5_HL_IMPORT_LIB} )
     message(STATUS "HDF5: autodiscovery is broken on WIN32; using global search paths")
     message(STATUS "HDF5: found ${HDF5_LIBRARIES}")
   else()
     find_package(HDF5 REQUIRED)
   endif()
   include_directories(${HDF5_INCLUDE_DIR})
   add_definitions(${HDF5_CPPFLAGS})
   add_definitions(-DWITH_HDF5)
else()
   message(STATUS "build without HDF5")
endif()

#--------------------------------------------------------------
# MATLAB
#--------------------------------------------------------------
if(WITH_MATLAB)
  message(STATUS "build with MatLab support")
  find_package(MATLAB REQUIRED)
  message(STATUS "Matlab include dir: ${MATLAB_INCLUDE_DIR}")
  message(STATUS "Matlab libmex: ${MATLAB_MEX_LIBRARY}")
  message(STATUS "Matlab libeng: ${MATLAB_ENG_LIBRARY}")
  message(STATUS "Matlab libmx:  ${MATLAB_MX_LIBRARY}")

  #include_directories(${MATLAB_INCLUDE_DIR})
  #add_definitions(-DWITH_MATLAB)
endif(WITH_MATLAB)

#--------------------------------------------------------------
# TRWS
#--------------------------------------------------------------
if(WITH_TRWS)
   message(STATUS "build with external inference algorithm TRWS")
   SET(TRWS_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/TRWS-v1.3.src-patched" CACHE STRING "TRWS patched source code directory")
   add_definitions(-DWITH_TRWS)
   include_directories(${TRWS_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm TRWS")
endif(WITH_TRWS)

#--------------------------------------------------------------
# GCO
#--------------------------------------------------------------
if(WITH_GCO)
   message(STATUS "build with external inference algorithm GCO")
   SET(GCO_LABEL_VALUE "int" CACHE STRING "selected label type for GCO library")
   add_definitions(-DGCOLABELVALUE=${GCO_LABEL_VALUE})
   SET(GCO_ENERGY_VALUE "double" CACHE STRING "selected energy type for GCO library")
   add_definitions(-DGCOENERGYVALUE=${GCO_ENERGY_VALUE})
   SET(GCO_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/GCO-v3.0.src-patched" CACHE STRING "GCO patched source code directory")
   add_definitions(-DWITH_GCO)
   include_directories(${GCO_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm GCO")
endif(WITH_GCO)

#--------------------------------------------------------------
# MRF
#--------------------------------------------------------------
if(WITH_MRF)
   message(STATUS "build with external inference algorithm MRF")
   SET(MRF_LABEL_VALUE "int" CACHE STRING "selected label type for MRF library")
   add_definitions(-DMRFLABELVALUE=${MRF_LABEL_VALUE})
   SET(MRF_ENERGY_VALUE "double" CACHE STRING "selected energy type for MRF library")
   add_definitions(-DMRFENERGYVALUE=${MRF_ENERGY_VALUE})
   SET(MRF_COST_VALUE "double" CACHE STRING "selected cost type for MRF library")
   add_definitions(-DMRFCOSTVALUE=${MRF_COST_VALUE})
   SET(MRF_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/MRF-v2.1.src-patched" CACHE STRING "MRF patched source code directory") 
 
   add_definitions(-DWITH_MRF)
   include_directories(${MRF_PATCHEDSRCDIR})

   set(bitness 32)
   if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      MESSAGE (STATUS "Detected a 64 Bit Machine")
      set(bitness 64)
      add_definitions(-DUSE_64_BIT_PTR_CAST)
   else()
      MESSAGE (STATUS "Detected a 32 Bit Machine")
   endif()
  
   #TODO add 64 bit check here!
   #if(64Bit???)
     #add_definitions(-DUSE_64_BIT_PTR_CAST)
   #endif(64Bit???)      
else()
   message(STATUS "build without external inference algorithm MRF")
endif(WITH_MRF)

#--------------------------------------------------------------
# QPBO
#--------------------------------------------------------------
if(WITH_QPBO)
   message(STATUS "build with external inference algorithm QPBO")
   SET(QPBO_PATCHEDSRCDIR "${PROJECT_SOURCE_DIR}/src/external/QPBO-v1.3.src-patched" CACHE STRING "QPBO patched source code directory")
   add_definitions(-DWITH_QPBO)
   include_directories(${QPBO_PATCHEDSRCDIR})
else()
   message(STATUS "build without external inference algorithm QPBO")
endif(WITH_QPBO)

#--------------------------------------------------------------
# FastPD
#--------------------------------------------------------------
if(WITH_FASTPD)
   message(STATUS "build with external inference algorithm FastPD")
   SET(FASTPD_URL "" CACHE STRING "URL for downloading FastPD (Registration required at http://www.csd.uoc.gr/~komod/FastPD/)")
   SET(FASTPD_ENERGY_VALUE "double" CACHE STRING "selected energy type for FASTPD library")

=== src/CMakeLists.txt ===
if(BUILD_EXAMPLES)
   add_subdirectory(examples)
endif()

add_subdirectory(external)
add_subdirectory(interfaces)
add_subdirectory(converter)
if(BUILD_TUTORIALS)
   add_subdirectory(tutorials)
endif()

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/sandbox/CMakeLists.txt")
  message(STATUS "Including ${CMAKE_CURRENT_SOURCE_DIR}/sandbox/CMakeLists.txt")
  add_subdirectory(sandbox)
endif()

=== src/converter/CMakeLists.txt ===
if(BUILD_CONVERTER)
  #  if(WITH_HDF5 AND WITH_BOOST)
  #      find_package(Boost 1.47 REQUIRED COMPONENTS program_options)
  #      message(STATUS "adding FORMAT CONVERTER")
  #      add_executable(opengm1TOopengm2 opengm1TOopengm2.cxx ${headers})
  #      target_link_libraries(opengm1TOopengm2 ${HDF5_CORE_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY})
  #      if(UNIX)
  #          find_library(RT rt)
  #          target_link_libraries(opengm1TOopengm2 rt)
  #      endif(UNIX)
  #      INSTALL_TARGETS(/bin/converter opengm1TOopengm2)
  #  else()
  #      message(STATUS "Not building format converter **")
  #  endif()

    if(WITH_HDF5)    
      add_executable(opengm2uai opengm2uai.cxx ${headers})
      target_link_libraries(opengm2uai ${HDF5_LIBRARIES})  
      INSTALL_TARGETS(/bin/converter opengm2uai)
      
      add_executable(uai2opengm uai2opengm.cxx ${headers})
      target_link_libraries(uai2opengm ${HDF5_LIBRARIES})  
      INSTALL_TARGETS(/bin/converter uai2opengm)
      
      add_executable(partition2potts partition2potts.cxx ${headers})
      target_link_libraries(partition2potts ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter partition2potts) 

      add_executable(opengm-brain-converter brain.cxx ${headers})
      target_link_libraries(opengm-brain-converter ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter opengm-brain-converter)
      
      add_executable(opengm2wudag opengm2wudag.cxx ${headers})
      target_link_libraries(opengm2wudag ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter opengm2wudag)

      add_executable(matching2opengm matching2opengm.cxx ${headers})
      target_link_libraries(matching2opengm ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter matching2opengm)    

      add_executable(matching2opengm-N2N matching2opengm-N2N.cxx ${headers})
      target_link_libraries(matching2opengm-N2N ${HDF5_LIBRARIES})   
      INSTALL_TARGETS(/bin/converter matching2opengm-N2N)    
    endif()
endif()

=== src/examples/CMakeLists.txt ===
add_subdirectory(image-processing-examples)
add_subdirectory(io-examples)
add_subdirectory(unsorted-examples)
add_subdirectory(constrained-graphical-models-examples)

=== src/external/CMakeLists.txt ===
add_subdirectory(patches)

IF(WITH_QPBO)
    SET(QPBO_SRC_FILES
        ${QPBO_PATCHEDSRCDIR}/QPBO_extra.cpp
        ${QPBO_PATCHEDSRCDIR}/QPBO.cpp
        ${QPBO_PATCHEDSRCDIR}/QPBO_maxflow.cpp
        ${QPBO_PATCHEDSRCDIR}/QPBO_postprocessing.cpp
    )
    
    SET(QPBO_SRC_FILES_EXIST 1)
    FOREACH(f ${QPBO_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(QPBO_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
     
    IF(DEFINED QPBO_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-qpbo
                  ${QPBO_SRC_FILES}
      )
      ADD_LIBRARY(external-library-qpbo-shared SHARED
                  ${QPBO_SRC_FILES}
      )
    ELSE(DEFINED QPBO_SRC_FILES_EXIST)
        MESSAGE ("QPBO not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED QPBO_SRC_FILES_EXIST)
ENDIF()

IF(WITH_TRWS)
    SET(TRWS_SRC_FILES
        ${TRWS_PATCHEDSRCDIR}/minimize.cpp
        ${TRWS_PATCHEDSRCDIR}/MRFEnergy.cpp
        ${TRWS_PATCHEDSRCDIR}/ordering.cpp
        ${TRWS_PATCHEDSRCDIR}/treeProbabilities.cpp
    )
    
    SET(TRWS_SRC_FILES_EXIST 1)
    FOREACH(f ${TRWS_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(TRWS_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
     
    IF(DEFINED TRWS_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-trws
                  ${TRWS_SRC_FILES}
      )
      ADD_LIBRARY(external-library-trws-shared SHARED
                  ${TRWS_SRC_FILES}
      )
    ELSE(DEFINED TRWS_SRC_FILES_EXIST)
        MESSAGE ("TRWS not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED TRWS_SRC_FILES_EXIST)
ENDIF()


IF(WITH_GCO)
    SET(GCO_SRC_FILES
        ${GCO_PATCHEDSRCDIR}/GCoptimization.cpp
        ${GCO_PATCHEDSRCDIR}/graph.cpp
        ${GCO_PATCHEDSRCDIR}/LinkedBlockList.cpp
        ${GCO_PATCHEDSRCDIR}/maxflow.cpp
	${GCO_PATCHEDSRCDIR}/instances.inc
    )
    
    SET(GCO_SRC_FILES_EXIST 1)
    FOREACH(f ${GCO_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(GCO_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
     
    IF(DEFINED GCO_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-gco
                  ${GCO_SRC_FILES}
      ) 
      ADD_LIBRARY(external-library-gco-shared SHARED
                  ${GCO_SRC_FILES}
      )
    ELSE(DEFINED GCO_SRC_FILES_EXIST)
        MESSAGE ("GCO not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED GCO_SRC_FILES_EXIST)
ENDIF()

IF(WITH_MAXFLOW)
    SET(MAXFLOW_SRC_FILES
        ${MAXFLOW_PATCHEDSRCDIR}/graph.cpp
        ${MAXFLOW_PATCHEDSRCDIR}/maxflow.cpp
    )
    
    SET(MAXFLOW_SRC_FILES_EXIST 1)
    FOREACH(f ${MAXFLOW_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(MAXFLOW_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
     
    IF(DEFINED MAXFLOW_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-maxflow
                  ${MAXFLOW_SRC_FILES}
      )
      ADD_LIBRARY(external-library-maxflow-shared SHARED
                  ${MAXFLOW_SRC_FILES}
      )  
    ELSE(DEFINED MAXFLOW_SRC_FILES_EXIST)
        MESSAGE ("MAXFLOW not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED MAXFLOW_SRC_FILES_EXIST)
ENDIF()

IF(WITH_MAXFLOW_IBFS)
    SET(MAXFLOW_IBFS_SRC_FILES
        ${MAXFLOW_IBFS_PATCHEDSRCDIR}/ibfs.cpp
    )
    SET(MAXFLOW_IBFS_SRC_FILES_EXIST 1)
    FOREACH(f ${MAXFLOW_IBFS_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(MAXFLOW_IBFS_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
    
    IF(DEFINED MAXFLOW_IBFS_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-maxflow-ibfs 
                  ${MAXFLOW_IBFS_SRC_FILES}
      )
      ADD_LIBRARY(external-library-maxflow-ibfs-shared SHARED 
                  ${MAXFLOW_IBFS_SRC_FILES}
      )
    ELSE(DEFINED MAXFLOW_IBFS_SRC_FILES_EXIST)
        MESSAGE ("MAXFLOW_IBFS not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED MAXFLOW_IBFS_SRC_FILES_EXIST)
ENDIF()

IF(WITH_MRF)
    SET(MRF_SRC_FILES
        ${MRF_PATCHEDSRCDIR}/mrf.cpp
        ${MRF_PATCHEDSRCDIR}/ICM.cpp
        ${MRF_PATCHEDSRCDIR}/GCoptimization.cpp
        ${MRF_PATCHEDSRCDIR}/graph.cpp
        ${MRF_PATCHEDSRCDIR}/maxflow.cpp
        ${MRF_PATCHEDSRCDIR}/MaxProdBP.cpp
        ${MRF_PATCHEDSRCDIR}/LinkedBlockList.cpp
        ${MRF_PATCHEDSRCDIR}/regions-maxprod.cpp
        ${MRF_PATCHEDSRCDIR}/TRW-S.cpp
        ${MRF_PATCHEDSRCDIR}/BP-S.cpp
    )
    SET(MRF_SRC_FILES_EXIST 1)
    FOREACH(f ${MRF_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(MRF_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
     
    IF(DEFINED MRF_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-mrf
                  ${MRF_SRC_FILES}
      ) 
      ADD_LIBRARY(external-library-mrf-shared SHARED
                  ${MRF_SRC_FILES}
      )
    ELSE(DEFINED MRF_SRC_FILES_EXIST)
        MESSAGE ("MRF not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED MRF_SRC_FILES_EXIST)
ENDIF()

IF(WITH_FASTPD)
    SET(FASTPD_SRC_FILES
        ${FASTPD_PATCHEDSRCDIR}/graph.cpp
        ${FASTPD_PATCHEDSRCDIR}/LinkedBlockList.cpp
        ${FASTPD_PATCHEDSRCDIR}/maxflow.cpp
    )
    SET(FASTPD_SRC_FILES_EXIST 1)
    FOREACH(f ${FASTPD_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(FASTPD_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
    
    IF(DEFINED FASTPD_SRC_FILES_EXIST)    
      ADD_LIBRARY(external-library-fastpd
                  ${FASTPD_SRC_FILES}
      ) 
      ADD_LIBRARY(external-library-fastpd-shared SHARED
                  ${FASTPD_SRC_FILES}
      )
    ELSE(DEFINED FASTPD_SRC_FILES_EXIST)
        MESSAGE ("FASTPD not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED FASTPD_SRC_FILES_EXIST)
ENDIF()

IF(WITH_GRANTE)
    SET(GRANTE_SRC_FILES
        ${GRANTE_PATCHEDSRCDIR}/Factor.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorGraph.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorGraphModel.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorType.cpp        
        ${GRANTE_PATCHEDSRCDIR}/FactorGraphStructurizer.cpp
        ${GRANTE_PATCHEDSRCDIR}/DisjointSet.cpp
        ${GRANTE_PATCHEDSRCDIR}/LogSumExp.cpp
        ${GRANTE_PATCHEDSRCDIR}/TreeInference.cpp        
        ${GRANTE_PATCHEDSRCDIR}/GibbsSampler.cpp
        ${GRANTE_PATCHEDSRCDIR}/FunctionMinimization.cpp
        ${GRANTE_PATCHEDSRCDIR}/FunctionMinimizationProblem.cpp
        ${GRANTE_PATCHEDSRCDIR}/Likelihood.cpp        
        ${GRANTE_PATCHEDSRCDIR}/InferenceMethod.cpp
        ${GRANTE_PATCHEDSRCDIR}/ParameterEstimationMethod.cpp
        ${GRANTE_PATCHEDSRCDIR}/MaximumLikelihood.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorGraphObservation.cpp        
        ${GRANTE_PATCHEDSRCDIR}/Prior.cpp
        ${GRANTE_PATCHEDSRCDIR}/NormalPrior.cpp
        ${GRANTE_PATCHEDSRCDIR}/LaplacePrior.cpp
        ${GRANTE_PATCHEDSRCDIR}/MaximumPseudolikelihood.cpp        
        ${GRANTE_PATCHEDSRCDIR}/FactorGraphUtility.cpp
        ${GRANTE_PATCHEDSRCDIR}/Pseudolikelihood.cpp
        ${GRANTE_PATCHEDSRCDIR}/StudentTPrior.cpp
        ${GRANTE_PATCHEDSRCDIR}/StructuredLossFunction.cpp        
        ${GRANTE_PATCHEDSRCDIR}/StructuredHammingLoss.cpp
        ${GRANTE_PATCHEDSRCDIR}/StructuredSVM.cpp
        ${GRANTE_PATCHEDSRCDIR}/StochasticFunctionMinimizationProblem.cpp
        ${GRANTE_PATCHEDSRCDIR}/StochasticFunctionMinimization.cpp        
        ${GRANTE_PATCHEDSRCDIR}/StructuredPerceptron.cpp
        ${GRANTE_PATCHEDSRCDIR}/RandomFactorGraphGenerator.cpp
        ${GRANTE_PATCHEDSRCDIR}/VAcyclicDecomposition.cpp
        ${GRANTE_PATCHEDSRCDIR}/SubFactorGraph.cpp        
        ${GRANTE_PATCHEDSRCDIR}/FactorConditioningTable.cpp
        ${GRANTE_PATCHEDSRCDIR}/ConditionedFactorType.cpp
        ${GRANTE_PATCHEDSRCDIR}/Conditioning.cpp
        ${GRANTE_PATCHEDSRCDIR}/MaximumCompositeLikelihood.cpp        
        ${GRANTE_PATCHEDSRCDIR}/TreeCoverDecomposition.cpp
        ${GRANTE_PATCHEDSRCDIR}/LinearProgrammingMAPInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorDataSource.cpp
        ${GRANTE_PATCHEDSRCDIR}/FactorGraphPartialObservation.cpp        
        ${GRANTE_PATCHEDSRCDIR}/BeliefPropagation.cpp
        ${GRANTE_PATCHEDSRCDIR}/RBFNetworkRegression.cpp
        ${GRANTE_PATCHEDSRCDIR}/RBFNetwork.cpp
        ${GRANTE_PATCHEDSRCDIR}/NonlinearRBFFactorType.cpp        
        ${GRANTE_PATCHEDSRCDIR}/GibbsInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/StructuredMeanFieldInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/ExpectationMaximization.cpp
        ${GRANTE_PATCHEDSRCDIR}/RandomSource.cpp
        ${GRANTE_PATCHEDSRCDIR}/AISInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/SimulatedAnnealingInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/MaximumCrissCrossLikelihood.cpp
        ${GRANTE_PATCHEDSRCDIR}/DiffusionInference.cpp        
        ${GRANTE_PATCHEDSRCDIR}/BruteForceExactInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/LinearFactorType.cpp
        ${GRANTE_PATCHEDSRCDIR}/NaivePiecewiseTraining.cpp
        ${GRANTE_PATCHEDSRCDIR}/ContrastiveDivergence.cpp
        ${GRANTE_PATCHEDSRCDIR}/ContrastiveDivergenceTraining.cpp
        ${GRANTE_PATCHEDSRCDIR}/HyperbolicPrior.cpp
        ${GRANTE_PATCHEDSRCDIR}/CompositeMinimization.cpp
        ${GRANTE_PATCHEDSRCDIR}/CompositeMinimizationProblem.cpp        
        ${GRANTE_PATCHEDSRCDIR}/SwendsenWangSampler.cpp
        ${GRANTE_PATCHEDSRCDIR}/SwendsenWangInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/ParallelTemperingInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/SAMCInference.cpp        
        ${GRANTE_PATCHEDSRCDIR}/TestModels.cpp
        ${GRANTE_PATCHEDSRCDIR}/NaiveMeanFieldInference.cpp
        ${GRANTE_PATCHEDSRCDIR}/MaximumTreePseudoLikelihood.cpp
        ${GRANTE_PATCHEDSRCDIR}/DisjointSetBT.cpp        
        ${GRANTE_PATCHEDSRCDIR}/MultichainGibbsInference.cpp
    )
    
    SET(GRANTE_SRC_FILES_EXIST 1)
    FOREACH(f ${GRANTE_SRC_FILES})
        IF(NOT EXISTS ${f})
            UNSET(GRANTE_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
    ENDFOREACH(f)
    
    IF(DEFINED GRANTE_SRC_FILES_EXIST)
      add_definitions(-fopenmp -fno-omit-frame-pointer -std=c++0x)    
      ADD_LIBRARY(external-library-grante
                  ${GRANTE_SRC_FILES}
      )
    ELSE(DEFINED GRANTE_SRC_FILES_EXIST)
        MESSAGE ("Grante not installed, run make externalLibs first and configure again")
    ENDIF(DEFINED GRANTE_SRC_FILES_EXIST)
ENDIF()

IF(WITH_AD3)
   # source files
   set(AD3_SRC_FILES
      ${AD3_PATCHEDSRCDIR}/ad3/FactorGraph.cpp
      ${AD3_PATCHEDSRCDIR}/ad3/GenericFactor.cpp
      ${AD3_PATCHEDSRCDIR}/ad3/Factor.cpp
      ${AD3_PATCHEDSRCDIR}/ad3/Utils.cpp
   )
   SET(AD3_SRC_FILES_EXIST 1)
   FOREACH(f ${AD3_SRC_FILES})
       IF(NOT EXISTS ${f})
            UNSET(AD3_SRC_FILES_EXIST)
        ENDIF(NOT EXISTS ${f})
   ENDFOREACH(f)

  IF(DEFINED AD3_SRC_FILES_EXIST)
    include_directories( ${AD3_PATCHEDSRCDIR}/ad3 )
    include_directories( ${AD3_PATCHEDSRCDIR}/Eigen )
    ADD_LIBRARY(external-library-ad3   ${AD3_SRC_FILES})
    ADD_LIBRARY(external-library-ad3-shared   SHARED ${AD3_SRC_FILES} )
      

  ELSE(DEFINED AD3_SRC_FILES_EXIST)
    MESSAGE ("Ad3 not installed, run make externalLibs first and configure again")
  ENDIF(DEFINED AD3_SRC_FILES_EXIST)

ENDIF()


IF(WITH_DAOOPT)
   # zlib source files
   set(DAOOPT_ZLIB_SRC_FILES
      ${DAOOPT_SRCDIR}/lib/zlib/adler32.c
      ${DAOOPT_SRCDIR}/lib/zlib/compress.c
      ${DAOOPT_SRCDIR}/lib/zlib/crc32.c
      ${DAOOPT_SRCDIR}/lib/zlib/deflate.c
      ${DAOOPT_SRCDIR}/lib/zlib/gzclose.c
      #${DAOOPT_SRCDIR}/lib/zlib/gzio.c
      ${DAOOPT_SRCDIR}/lib/zlib/gzlib.c
      ${DAOOPT_SRCDIR}/lib/zlib/gzread.c
      ${DAOOPT_SRCDIR}/lib/zlib/gzwrite.c
      ${DAOOPT_SRCDIR}/lib/zlib/infback.c
      ${DAOOPT_SRCDIR}/lib/zlib/inffast.c
      ${DAOOPT_SRCDIR}/lib/zlib/inflate.c
      ${DAOOPT_SRCDIR}/lib/zlib/inftrees.c
      ${DAOOPT_SRCDIR}/lib/zlib/trees.c

=== src/interfaces/CMakeLists.txt ===
IF(BUILD_COMMANDLINE)
  add_subdirectory(commandline)
ENDIF()
if(BUILD_PYTHON_WRAPPER)
   add_subdirectory(python)
endif() 
IF(BUILD_MATLAB_WRAPPER)
  add_subdirectory(matlab)
ENDIF()

=== src/tutorials/CMakeLists.txt ===
add_subdirectory(c++)

=== src/unittest/CMakeLists.txt ===

add_definitions(-DOPENGM_DEBUG)

if(BUILD_TESTING)

   add_executable(test-partitions test_partitions.cxx ${headers})
   add_test(test-partitions ${CMAKE_CURRENT_BINARY_DIR}/test-partitions)


   add_executable(test-gm-learning-functions test_gm_learning_functions.cxx ${headers})
   add_test(test-gm-learning-functions ${CMAKE_CURRENT_BINARY_DIR}/test-gm-learning-functions)


   add_executable(test-graphicalmodelmanipulator test_graphicalmodelmanipulator.cxx ${headers})
   add_test(test-graphicalmodelmanipulator ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodelmanipulator)

   add_executable(test-explicit-storage test_explicit_storage.cxx ${headers})
   add_test(test-explicit-storage ${CMAKE_CURRENT_BINARY_DIR}/test-explicit-storage)

   add_executable(test-types test_types.cxx ${headers})
   add_test(test-types ${CMAKE_CURRENT_BINARY_DIR}/test-types)

   add_executable(test-test-type-sizes-for-hdf5 test_type_sizes_for_hdf5.cxx ${headers})
   add_test(test-test-type-sizes-for-hdf5 ${CMAKE_CURRENT_BINARY_DIR}/test-test-type-sizes-for-hdf5)

   #add_executable(test-sparsemarray test_sparsemarray.cxx ${headers})
   add_test(test-fast-sequence ${CMAKE_CURRENT_BINARY_DIR}/test-fast-sequen)
   add_executable(test-fast-sequence test_fast_sequence.cxx ${headers})
   add_test(test-fast-sequence ${CMAKE_CURRENT_BINARY_DIR}/test-fast-sequence)

   add_executable(test-functions test_functions.cxx ${headers})
   add_test(test-functions ${CMAKE_CURRENT_BINARY_DIR}/test-functions) 

   add_executable(test-learnable-functions test_learnable_functions.cxx ${headers})
   add_test(test-learnable-functions ${CMAKE_CURRENT_BINARY_DIR}/test-learnable-functions)

   add_executable(test-factor test_factor.cxx ${headers})
   add_test(test-factor ${CMAKE_CURRENT_BINARY_DIR}/test-factor)

   add_executable(test-discretespaces test_discretespaces.cxx ${headers})
   add_test(test-discretespaces ${CMAKE_CURRENT_BINARY_DIR}/test-discretespaces)

   add_executable(test-graphicalmodel test_graphicalmodel.cxx ${headers})
   add_test(test-graphicalmodel ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodel)

   add_executable(test-factorgraph test_factorgraph.cxx ${headers})
   add_test(test-factorgraph ${CMAKE_CURRENT_BINARY_DIR}/test-factorgraph)

   add_executable(test-graphicalmodeldecomposer test_graphicalmodeldecomposer.cxx ${headers})
   add_test(test-graphicalmodeldecomposer ${CMAKE_CURRENT_BINARY_DIR}/test-graphicalmodeldecomposer)

   add_executable(test-operate test_operate.cxx ${headers})
   add_test(test-operate ${CMAKE_CURRENT_BINARY_DIR}/test-operate)

   add_executable(test-operations test_operations.cxx ${headers})
   add_test(test-operations ${CMAKE_CURRENT_BINARY_DIR}/test-operations)

   add_executable(test-accumulate test_accumulate.cxx ${headers})
   add_test(test-accumulate ${CMAKE_CURRENT_BINARY_DIR}/test-accumulate)

   add_executable(test-randomaccessset test_randomaccessset.cxx ${headers})
   add_test(test-randomaccessset ${CMAKE_CURRENT_BINARY_DIR}/test-randomaccessset)

   add_executable(test-tribool test_tribool.cxx ${headers})
   add_test(test-tribool ${CMAKE_CURRENT_BINARY_DIR}/test-tribool)

   add_executable(test-accessor-iterator test_accessor_iterator.cxx ${headers})
   add_test(test-accessor-iterator ${CMAKE_CURRENT_BINARY_DIR}/test-accessor-iterator)

   add_executable(test-random test_random_1.cxx ${headers})
   add_test(test-random ${CMAKE_CURRENT_BINARY_DIR}/test-random) 

   ADD_EXECUTABLE(test-primal-lpbound test_primal_lpbound.cpp ${headers}) 
   add_test(test-primal-lpbound ${CMAKE_CURRENT_BINARY_DIR}/test-primal-lpbound) 

   ADD_EXECUTABLE(test-transportsolver test_transportsolver.cpp ${headers})
   add_test(test-transportsolver ${CMAKE_CURRENT_BINARY_DIR}/test-transportsolver) 

   if(WITH_HDF5)
      add_executable(test-io-hdf5 test_io_hdf5.cxx ${headers})
      target_link_libraries(test-io-hdf5 ${HDF5_LIBRARIES})
      add_test(test-io-hdf5 ${CMAKE_CURRENT_BINARY_DIR}/test-io-hdf5)
   endif()

   if(WITH_MEMINFO)
      ADD_EXECUTABLE(test-memoryinfo test_memoryinfo.cxx ${headers})
      add_test(test-memoryinfo ${CMAKE_CURRENT_BINARY_DIR}/test-memoryinfo) 
   endif()

   add_executable(test-lp-solver test_lp_solver.cxx ${headers})
   add_test(test-lp-solver ${CMAKE_CURRENT_BINARY_DIR}/test-lp-solver) 
   if(WITH_CPLEX)
      if(WIN32)
         target_link_libraries(test-lp-solver wsock32.lib ${CPLEX_LIBRARIES} )
      else(WIN32)
         target_link_libraries(test-lp-solver ${CMAKE_THREAD_LIBS_INIT} ${CPLEX_LIBRARIES} )
      endif(WIN32)
   endif(WITH_CPLEX)
   if(WITH_GUROBI)
      target_link_libraries(test-lp-solver
         ${GUROBI_LIBRARIES}
         ${GUOBI_CXX_LIBRARY}  
         ${GUROBI_LIBRARY}
         ${CMAKE_THREAD_LIBS_INIT}
      )
   endif(WITH_GUROBI)
   if(LINK_RT)
      target_link_libraries(test-lp-solver rt)
   endif(LINK_RT)
   
   add_executable(test-indicator-variable test_indicator_variable.cxx ${headers})
   add_test(test-indicator-variable ${CMAKE_CURRENT_BINARY_DIR}/test-indicator-variable)
   
   add_executable(test-linear-constraint test_linear_constraint.cxx ${headers})
   add_test(test-linear-constraint ${CMAKE_CURRENT_BINARY_DIR}/test-linear-constraint)
   
   add_executable(test-subsequence-iterator test_subsequence_iterator.cxx ${headers})
   add_test(test-subsequence-iterator ${CMAKE_CURRENT_BINARY_DIR}/test-subsequence-iterator)
   
   add_executable(test-lp-functiontransfer test_lp_functiontransfer.cxx ${headers})
   add_test(test-lp-functiontransfer ${CMAKE_CURRENT_BINARY_DIR}/test-lp-functiontransfer)
   
   add_executable(test-canonicalview test_canonicalview.cxx ${headers})
   add_test(test-canonicalview ${CMAKE_CURRENT_BINARY_DIR}/test-canonicalview)

   add_subdirectory(inference)
endif()

=== src/examples/image-processing-examples/CMakeLists.txt ===
add_executable(example-grid-potts grid_potts.cxx ${headers})
#add_executable(example-recognition recognition.cxx ${headers})
add_executable(example-segmentation interpixel_boundary_segmentation.cxx ${headers})

if(WIN32 OR APPLE)

else()
  find_library(RT_LIBRARY rt)
  target_link_libraries(example-grid-potts rt)
  #target_link_libraries(example-recognition rt)
  target_link_libraries(example-segmentation rt)
endif()

=== src/examples/io-examples/CMakeLists.txt ===
if(WITH_HDF5 AND HDF5_FOUND)
   add_executable(example-io io_graphical_model.cxx ${headers})
   if(WIN32 OR APPLE)
      target_link_libraries(example-io ${HDF5_LIBRARIES})
   else()
      target_link_libraries(example-io ${HDF5_LIBRARIES} rt)
   endif()
endif()

=== src/interfaces/commandline/CMakeLists.txt ===
# if(WITH_HDF5)
#    add_executable(opengm opengm.cxx ${headers})
#    target_link_libraries(opengm ${HDF5_LIBRARIES} hdf5_cpp)
#    if(UNIX)
#        find_library(RT rt)
#        target_link_libraries(opengm rt)
#    endif(UNIX)
#    INSTALL_TARGETS(/bin opengm)
# endif(WITH_HDF5)

 add_subdirectory(double)
# add_subdirectory(float)

=== src/interfaces/matlab/CMakeLists.txt ===
if(WITH_MATLAB)
  include_directories(${MATLAB_INCLUDE_DIR})
  add_definitions(-DWITH_MATLAB)
endif(WITH_MATLAB)

add_subdirectory(opengm)

=== debian/changelog ===
opengm (2.3.6+20160905-1+rpi1) buster-staging; urgency=medium

  [Changes taken from 2.3.6+20160905-1ubuntu1 by Dimitri John Ledkov <xnox@ubuntu.com>]
  * Disable python wrapper, as it is not ported to boost numpy.

 -- Peter Micheal Green <plugwash@raspbian.org>  Thu, 20 Dec 2018 18:55:05 +0000

=== debian/control ===
Source: opengm
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               libboost-dev,
               libboost-graph-dev,
               libboost-python-dev,
               libhdf5-dev,
               python,
               python-nose,
               python-numpy
Build-Depends-Indep: doxygen,
                     graphviz,
                     python-sphinx
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/opengm.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/opengm.git
Homepage: http://hci.iwr.uni-heidelberg.de/opengm2/
X-Python-Version: >= 2.6

Package: libopengm-bin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command line tools for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the commandline interface to the OpenGM library.

Package: libopengm-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Suggests: libopengm-doc
Description: C++ template library for discrete factor graph models
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the development headers for the OpenGM library.

Package: libopengm-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: documentation and examples for OpenGM
 OpenGM is a C++ template library for discrete factor graph models and
 distributive operations on these models.
 .
 It includes state-of-the-art optimization and inference algorithms beyond
 message passing. OpenGM handles large models efficiently, is modular and
 extendible. The graphical model data structure, inference algorithms and
 different encodings of functions inter-operate through well-defined
 interfaces. The binary OpenGM file format is based on the HDF5 standard and
 incorporates user extensions automatically.
 .
 This package contains the API documentation and example source code for the
 OpenGM library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Hardening options.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Set the build directory explicitly.
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture --query DEB_HOST_GNU_TYPE)
BUILDDIR = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)

BUILD_OPTIONS = \
	-DBUILD_COMMANDLINE=ON \
	-DBUILD_CONVERTER=ON \
	-DBUILD_EXAMPLES=OFF \
	-DBUILD_PYTHON_WRAPPER=OFF \
	-DBUILD_TUTORIALS=OFF \
	-DCMAKE_SKIP_RPATH=ON \
	-DWITH_BOOST=ON \
	-DWITH_HDF5=ON \
	-DWITH_OPENMP=ON \
	-DWITH_VIGRA=OFF

# Build tests subject to nocheck.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	BUILD_OPTIONS += -DBUILD_TESTING=ON
else
	BUILD_OPTIONS += -DBUILD_TESTING=OFF
endif

%:
	dh $@ --parallel --builddirectory=$(BUILDDIR) --with python2

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCS=OFF \
		-DBUILD_PYTHON_DOCS=OFF

override_dh_auto_configure-indep:
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCS=ON \
		-DBUILD_PYTHON_DOCS=ON

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --package=libopengm-doc

override_dh_installexamples:
	dh_installexamples --exclude=CMakeLists.txt

override_dh_python2:
	dh_python2
	dh_numpy

override_dh_compress:
	dh_compress --exclude=examples
